-- LOVELACE version 1
-- Copyright JM Alliot 
-- 18 May 2006
-- This is a chess engine xboard compatible written in full ADA
-- with some lines of assembly code
-- It is bitboard based and uses extensively ADA representation clauses
-- Endgames are terrible
-- Draws by repetion are not detected correctly
-- The evaluation function is very bad (and very short..)
-- Use at your own risk...

with Interfaces;
use Interfaces;
with System.Machine_Code;
use System.Machine_Code;
with Ada.Characters.Latin_1;
use Ada.Characters.Latin_1;


package body Bitscan  is
   function First_One(A:Intboard) return Natural  is
      S:Halfboard;
      for S'Address use A'Address;
      R:Integer_32;
   begin
      pragma Assert(A/=0,"A equals to 0");
      Asm(
          "bsfl %%eax,%%eax"& LF & HT &
          "jnz 1f"& LF & HT &
          "bsfl %%edx,%%eax"& LF & HT &
          "jz 1f"& LF & HT &
          "addl $32,%%eax"& LF & HT &
          "1: ",
          Inputs => (Unsigned_32'Asm_Input ("a",S.L),
                     Unsigned_32'Asm_Input ("d",S.H)),
          Outputs => Integer_32'Asm_Output ("=a", R),
          Clobber => "");
      return(Natural(R));
   end First_One;

   function Last_One(A:Intboard) return Natural is
      S:Halfboard ;
      for S'Address use A'Address;
      R:Integer_32;
   begin
      pragma Assert(A/=0,"A equals to 0");
      Asm(
          "bsrl %%eax,%%eax"& LF & HT &
          "jz 2f"& LF & HT &
          "addl $32,%%eax"& LF & HT &
          "jmp 1f"& LF & HT &
          "2: bsrl %%edx,%%eax"& LF & HT &
          "1: ",
          Inputs => (Unsigned_32'Asm_Input ("d",S.L),
                     Unsigned_32'Asm_Input ("a",S.H)),
          Outputs => Integer_32'Asm_Output ("=a", R),
          Clobber => "");
      return(Natural(R));
   end Last_One;


   function Count_Bits(A:Intboard) return Natural is
      S:Halfboard ;
      for S'Address use A'Address;
      R:Integer_32;
   begin
      pragma Assert(A/=0,"A equals to 0");
      Asm(
          "xorl %%ecx,%%ecx"& LF & HT &
          "testl %%eax,%%eax"& LF & HT &
          "jz 2f"& LF & HT &
          "1: leal -1(%%eax),%%ebx"& LF & HT &
          "incl %%ecx"& LF & HT &
          "andl %%ebx,%%eax"& LF & HT &
          "jnz 1b"& LF & HT &
          "2: testl %%edx,%%edx"& LF & HT &
          "jz 4f"& LF & HT &
          "3: leal -1(%%edx),%%ebx"& LF & HT &
          "incl %%ecx"& LF & HT &
          "andl %%ebx,%%edx"& LF & HT &
          "jnz 3b"& LF & HT &
          "4: movl %%ecx,%%eax",
          Inputs => (Unsigned_32'Asm_Input ("d",S.L),
                     Unsigned_32'Asm_Input ("a",S.H)),
          Outputs => Integer_32'Asm_Output ("=a", R),
          Clobber => "ebx,ecx");
      return(Natural(R));
   end Count_Bits;


end Bitscan;
