-- LOVELACE version 1
-- Copyright JM Alliot 
-- 18 May 2006
-- This is a chess engine xboard compatible written in full ADA
-- with some lines of assembly code
-- It is bitboard based and uses extensively ADA representation clauses
-- Endgames are terrible
-- Draws by repetion are not detected correctly
-- The evaluation function is very bad (and very short..)
-- Use at your own risk...

with Text_Io;
use Text_Io;
with Bitboards;
use Bitboards;
with Bitscan;
use Bitscan;
with Move;
use Move;
with Eval;
use Eval;
with Hash;
use Hash;
with Xboard;
use Xboard;
with Calendar;
use Calendar;
with Hashbook;
use Hashbook;
with Ada.Real_Time;

procedure Main is
   Cast : Castling := (others=>True);
   Col, My_Col  : Color;
   En_Passant :Integer := -1;
   Res : Integer;
   P2 : Piece;
   N_En_Passant : Integer;
   N_Castles: Castling;
   Promote : Boolean;
   Matw, Matb : Integer;
   Valid : Boolean;
   S : String(1..255);
   Last : Integer;
   Prof : Integer;
   Dur : Integer;
   St : State;
   Lcb : array (0..63) of Piece;
   Start_Time_Real : Ada.Real_Time.Time;
   Real_Dur : Ada.Real_Time.Time_Span;
   Tmp : Integer;
   Alpha, Beta:Integer;
begin

--   Init_Boards("rnbqkbnr/pppppppp/8/8/4P3/8/PPPP1PPP/RNBQKBNR b KQkq e3 0 1");
--   Init_Boards("rnbqkbnr/pp1ppppp/8/2p5/4P3/8/PPPP1PPP/RNBQKBNR w KQkq c6 0 2");




--    Init_Boards("rnbqkbnr/pp1ppppp/8/2p5/4P3/5N2/PPPP1PPP/RNBQKB1R b KQkq - 1 2",Col,Cast,En_Passant);




--   Init_Boards("rnb2bnr/1p1ppkpp/pq6/2p5/4P3/8/PPPP1PPP/RNBQKB1R w KQkq - 1 2",Col,Cast,En_Passant);
--   Init_Boards("rnb2bnr/1p1ppkpp/pq6/2p5/2B1P3/8/PPPP1PPP/RNBQK2R b KQkq - 1 2",Col,Cast,En_Passant);
--   Init_Boards("rnbqkbnr/pp1ppppp/8/2p5/8/4PN2/PPP11PPP/RNBQKB1R b KQkq - 1 2",Col,Cast,En_passant);
--   Init_Boards("8/pp1ppppp/8/5R2/8/8/8/8 b KQkq - 1 2");
--   Init_Boards("8/pp1ppppp/8/4Q3/8/8/8/8 b KQkq - 1 2");
--      Init_Boards("8/3P4/8/4p3/8/8/8/8 b KQkq - 1 2");
--     Init_Boards("5q2/8/8/1k6/8/8/8/R3KR1r w KQkq - 1 2",Col,Cast,En_passant);
   --    Init_Boards("r3k2r/8/8/1K6/8/8/8/3Q4 b k - 1 2",Col,Cast,En_Passant);
--  Init_Boards("3rk2r/8/3q4/1K5b/6b1/8/8/RRRQ4 b - - 1 2",Col,Cast,En_Passant);
--   Init_Boards("RR2K2R/8/3Q4/k6B/6B1/8/8/rrr4q b - - 1 2",Col,Cast,En_Passant);




--   Init_Boards("rn2kbnr/p3pppp/62/1p1P4/2p4N/P1N1B2b/1P2BPqP/R2Q1RK w kq - 1 2",Col,Cast,En_Passant);


--   Init_Boards("3qB1k1/p1p2pbp/bp2pnp1/8/2PP4/N2Q4/PP2PP1p/R4RK w - - 1 2",Col,Cast,En_Passant);


-- This board is the classical starting board
   Init_Boards("rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1",Col,Cast,En_Passant,Matw,Matb);

--  Init_Boards("rn2k2r/1pq1bQpp/p1bp1n2/P1p1p1N1/8/2P1P2P/1P1P1PP1/RNB1KB1R b - - 1 2",Col,Cast,En_Passant);

   Init_Masks;
   Init_Attacks;
   Load_All;
   Make_Z_I(Col);
   First_Ply := 0;
   Movenum:=0;

   -- Warning
   Move_From := -1;Move_To := -1;My_Col := Black;
   while True loop
      <<Do_It_Again>>
      if Col/=My_Col or Xboard_Force then
        if Xboard_Force then Read_Xboard(-1,-1);
        else Read_Xboard(Move_From,Move_To); end if;
        if Xboard_From=-3 then
            Init_Boards(Xboard_Fen(1..Xboard_Fen_Last),Col,Cast,En_Passant,Matw,Matb);
            Init_Masks;
            Init_Attacks;
            Make_Z_I(Col);
            My_Col := -Col;
            Print_Chessboard(File_Log);
            goto Do_It_Again;
         end if;
         if Xboard_From = -2 then
            raise Sortie;
         end if;
         Move_From := Xboard_From;
         Move_To := Xboard_To;
         Res := 0;
         Put_Line(File_Log,Color'Image(Col)&Color'Image(My_Col)
                  &Boolean'Image(Xboard_Force));
         if Move_From = -1 then My_Col := Col; end if;
         Put_Line(File_Log,Color'Image(Col)&Color'Image(My_Col)
                  &Boolean'Image(Xboard_Force));
         Print_Chessboard(File_Log);
      end if;
      if Col = My_Col and not Xboard_Force Then
         begin
            Get_Book(Move_From,Move_To,Col,Cast,En_Passant);
            if Move_From/=-1 then raise  End_Thinking; end if;
            Move_From := -1;Move_To := -1;Prof := 10;Alpha:=-32767;Beta:=32767;
            loop
               Start_Time_real := Ada.Real_Time.Clock;
               Start_Time := Clock;
               select
                  delay 10.0;
                  Put_Line(File_Log,"Interrupted");
                  Restore_State(St);
                  for I in 0..63 loop Chess_Board(I) := Lcb(I); end loop;
                  raise End_Thinking;
               then abort
                  Save_State(St);
                  for I in 0..63 loop Lcb(I):=Chess_Board(I); end loop;
                  Nb_Pos :=0; Nb_Moves_Made := 0;Hash_Hits :=0; Max_Prof :=0;
                  loop
                     Res := Gen_Moves(alpha,beta,Col,En_passant,Cast,0,False,Prof,Matw,matb);
                     if Res=32766 or Res=-32766 then raise End_Thinking; end if;
                     if Res>Alpha and Res<Beta then exit; end if;
                     if Res<=Alpha then Alpha:= -32767;Beta:=Res+1;
                     else Beta:=32767;Alpha:=Res-1; end if;
                  end loop;
                  Alpha := Res-10;Beta:=Res+10;
                  End_Time := Clock;
                  Dur := Integer(End_Time-Start_Time);
                  Put_Line(File_log,"res:"&Integer'Image(Prof)&Integer'Image(Move_From)&Integer'Image(Move_To)&Integer'Image(Res)&Integer'Image(Dur));
                  Flush(File_Log);
                  if (XT1=0 and then Dur>XT3/2) or (XT3=0 and then Dur>((XT2*60)/XT1)/2) then
                     raise End_Thinking;
                  end if;
--                  if Prof=20 then raise End_Thinking; end if;
                  Prof := Prof+10;
               end select;
            end loop;
         exception
            when End_Thinking =>
               Put_Line(File_Log,"End thinking");
               Real_Dur := Ada.Real_Time."-"(Ada.Real_Time.Clock,Start_Time_Real);
               Dur := Integer(Clock-Start_Time);
               Put_Line(File_Log,Duration'Image(Ada.Real_Time.To_Duration(Real_Dur))&Integer'Image(Dur));
               Flush(File_Log);
         end;
      end if;
      Movenum := Movenum+1;
      Put_Line(File_log,"res:"&Integer'Image(Move_From)&Integer'Image(Move_To)&Integer'Image(Res));
      if Move_From = -1 Then exit; end if;
      Really_Do_Move (Move_From,Move_To,Col,Cast,En_Passant,P2,Promote,N_En_Passant,Valid,N_Castles);
      Put_Line(File_Log,Piece'Image(P2)&Integer'Image(Piece_Value(P2))&Boolean'Image(Promote));
      Flush(File_Log);
      if not Valid then
         Put_Line(File_Log,"erreur");
         Flush(File_Log);
         raise Constraint_Error;
        end if;
--      Print_Chessboard;
      Print_Fen(File_Log);
      if Promote then
         if Col=White then
            Matw := Matw-(Piece_Value(White_Pawn)-Piece_Value(White_Queen));
            Matb := Matb - Piece_Value(P2);
         else
            Matb := Matb-(Piece_Value(Black_Pawn)-Piece_Value(Black_Queen));
            Matw := Matw - Piece_Value(P2);
         end if;
      else
         if Col=White then
            Matb := Matb-Piece_Value(P2);
         else
            Matw := Matw-Piece_Value(P2);
         end if;
      end if;
      Cast := N_Castles;En_Passant := N_En_Passant;Col := -Col;
      if Promote or P2/= Empty or Chess_Board(Move_To)=Black_Pawn or Chess_Board(Move_To)=White_Pawn then
         First_Ply := Movenum;
      end if;
   end loop;
   Get_Line(S,last);
exception
   when Sortie =>
      Put_Line(File_Log,"Sortie raised, exiting");
      Flush(File_Log);
end Main;

